mod Ex07a

incl Mtex

incl Mauxa

loc rem 
  \para \bf  7. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.18 
  \para* \it  Datum:  \end stvrtok 12.4.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0607ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_bt_preorder
  Std('Preorder',0)

appldisp/1 Tex_f1_bt_inorder
  Std('Inorder',0)

appldisp/1 Tex_f1_bt_postorder
  Std('Postorder',0)

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Trees.  \end 

rem 
  \para \bf  Arithmetization of labeled binary trees.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \bf  [CL] Formatting the output.  \end Use the format \ft Bt \end to 
  display numbers as binary trees. Try out the following simple queries 
  \verbatim 
      171386336145149 = t:Bt
  \end
  \verbatim 
      1,10,(1,11,(0,0),0,0),(1,12,(0,0),0,0) = t:Bt
  \end

rem 
  \para \bf  Membership in binary trees.  \end 
  \header* pred/2 Inbt 'Tex_p2_bt_in' \end Define the predicate 
  \ft Inbt(x,t) \end such that 
  \eq* 
    ~Inbt(x,E)
  \end
  \eq* 
    Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)
  \end

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,t) <-> Poo

rem 
  \para \bf  Size and depth of binary trees.  \end 
  \header* fun Sz 'Tex_f1_bt_sz' \end \header* fun Dp 'Tex_f1_bt_dp' \end Define 
  the functions \ft Sz(t) \end and \ft Dp(t) \end computing respectively the 
  size and the depth of the binary tree \ft t \end. 

fun Sz 'Tex_f1_bt_sz'
  Sz(t) = Foo

fun Dp 'Tex_f1_bt_dp'
  Dp(t) = Foo

rem 
  \para \bf  Remark.  \end Note that we have 
  \eq* 
    Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))
  \end
  \para A binary tree \ft t \end is said to be \it  full  \end if 
  \eq* 
    Sz(t)+1 = Exp(2,Dp(t))
  \end

rem 
  \para \bf  Exercise.  \end \header* fun/2 Fullsame  \end Define the function 
  \ft Fullsame(x,n) \end such that 
  \eq* 
    Bt Fullsame(x,n)
  \end
  \eq* 
    Inbt(y,Fullsame(x,n)) -> y = x
  \end
  \eq* 
    Dp Fullsame(x,n) = n
  \end
  \eq* 
    Sz Fullsame(x,n)+1 = Exp(2,n)
  \end

fun/2 Fullsame 
  Fullsame(x,n) = Foo

rem 
  \para \bf  Exercise.  \end Define the function \ft Fulltree(n) \end such that 
  \eq* 
    Bt Fulltree(n)
  \end
  \eq* 
    Inbt(x,Fulltree(n)) <-> x+1 < Exp(2,n)
  \end
  \eq* 
    Dp Fulltree(n) = n
  \end
  \eq* 
    Sz Fulltree(n)+1 = Exp(2,n)
  \end
  \para \it  Hint.  \end \header* fun/2 Fulltree1  \end Define first an 
  auxiliary function \ft Fulltree1(k,n) \end such that 
  \eq* 
    Bt Fulltree1(k,n)
  \end
  \eq* 
    Inbt(x,Fulltree1(k,n)) <-> \e y(x = Dconc(k,y) & y+1 < Exp(2,n))
  \end
  \eq* 
    Dp Fulltree1(k,n) = n
  \end
  \eq* 
    Sz Fulltree1(k,n)+1 = Exp(2,n)
  \end
  \para Here \ft Dconc(x,y) \end is the dyadic concatenation. 

fun/2 Fulltree1 
  Fulltree1(k,n) = Foo

fun Fulltree 
  Fulltree(n) = Foo

rem 
  \para \bf  Reflection function.  \end Define the function \ft Reflect(t) \end 
  which yields the mirror's image of the binary tree \ft t \end. 

fun Reflect 
  Reflect(t) = Foo

rem 
  \para \bf  Traversals of binary trees.  \end 

fun Preorder 'Tex_f1_bt_preorder'
  Preorder(t) = Foo

fun Inorder 'Tex_f1_bt_inorder'
  Inorder(t) = Foo

fun Postorder 'Tex_f1_bt_postorder'
  Postorder(t) = Foo

rem 
  \para \bf  Fast programs for tree traversals.  \end Save the concatenation in 
  the definition of each tree traversal function. 

rem 
  \para \it  Fast preorder traversal.  \end 

fun/2 Fast_preorder 'Tex_f2_f'
  Fast_preorder(t,a) = Foo

rem 
  \para Invariant: 
  \eq* 
    Bt(t) -> Fast_preorder(t,a) = Preorder(t)++a
  \end

fun Preorder1 'Tex_f1_bt_preorder'
  Preorder1(t) = Foo

rem 
  \para \it  Fast inorder traversal.  \end 

fun Inorder1 'Tex_f1_bt_inorder'
  Inorder1(t) = Foo

rem 
  \para \it  Fast postorder traversal.  \end 

fun Postorder1 'Tex_f1_bt_postorder'
  Postorder1(t) = Foo

rem 
  \para \bf  Tail recursive tree traversals.  \end Find a tail recursive 
  derivation of each tree traversal function. 

rem 
  \para \it  Tail recursive preorder traversal.  \end 

fun/2 Tail_recursive_preorder 'Tex_f2_f'
  Tail_recursive_preorder(s,a) = Foo

rem 
  \para Invariant: 
  \eq* 
    Bt(t) -> 
    Tail_recursive_preorder((t,s),a) = Tail_recursive_preorder(s,Preorder(t)++a)
  \end

fun Preorder2 'Tex_f1_bt_preorder'
  Preorder2(t) = Foo

rem 
  \para \it  Tail recursive inorder traversal.  \end 

fun Inorder2 'Tex_f1_bt_inorder'
  Inorder2(t) = Foo

rem 
  \para \it  Tail recursive postorder traversal.  \end 

fun Postorder2 'Tex_f1_bt_postorder'
  Postorder2(t) = Foo

rem 
  \para \bf  Subtrees.  \end \header* pred/2 Subtree 'Tex_p2_bt_subtree' \end 
  Define the predicate \ft Subtree(t1,t2) \end such that 
  \eq* 
    Subtree(t,E) <-> t = E
  \end
  \eq* 
    Subtree(t,Nd(x,l,r)) <-> t = Nd(x,l,r) \/ Subtree(t,l) \/ Subtree(t,r)
  \end

pred/2 Subtree 'Tex_p2_bt_subtree'
  Subtree(t1,t2) <-> Poo

rem 
  \para \bf  Exercise.  \end Define the function \ft Subtrees(t) \end such that 
  \eq* 
    Bt(t) -> t1 in Subtrees(t) <-> Subtree(t1,t)
  \end

fun Subtrees 
  Subtrees(t) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc rem 
  \para \bf  [CL] Formatting the output.  \end Use the predicate \ft Lbt \end as 
  a format to display numbers as lists of binary trees. Try out query 
  \verbatim 
      Subtrees Nd(1,Nd(2,E,E),Nd(3,E,E)) = ts:Lbt
  \end

loc pred Lbt 
  Lbt(0)
  Lbt(t,ts) <- Bt(t) & Lbt(ts)

