mod Mauxb logic: 'cl'

incl Mtex

rem 
  \para \bf  Binary trees.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,Nd(y,l,r)) <- x = y
  Inbt(x,Nd(y,l,r)) <- x != y & Inbt(x,l)
  Inbt(x,Nd(y,l,r)) <- x != y & ~Inbt(x,l) & Inbt(x,r)

pred/2 Subtree 'Tex_p2_bt_subtree'
  Subtree(t1,t2) <- t1 = t2
  Subtree(t1,t2) <- t1 != t2 & t2 = Nd(x2,l2,r2) & Subtree(t1,l2)
  Subtree(t1,t2) <- 
    t1 != t2 & t2 = Nd(x2,l2,r2) & ~Subtree(t1,l2) & Subtree(t1,r2)

